
unit hiTextBlok;

interface

uses Windows,Messages,Kol,Share,Win; // ,hiFont;

const flag = DT_CENTER or DT_WORDBREAK or DT_WORD_ELLIPSIS;    

type
    
    PFigure = ^TFigure;        
    TFigure = record
     ParentrRect: integer;
     sText: string;
     hRegn: HRGN;
     rRect: TRect;
     rText: TRect;
     gFont: PGraphicTool;
     cFill: TColor;
     cFrame: TColor;
     Firstf: integer;
	 Secondf: integer; 
//	 NubFirstf: integer;
 //    Parent: PTree;
     end;
 
  
  THITextBlok = class(THIWin)
   private  
    eList: PList;                     // 
    Bmp: PBitmap;                     //           
    selRect: TRect;                   //  
    SelectUnit: array of integer;     //  ,     
    cVScroll: PControl;               //    
    cHScroll: PControl;               //    
    siV: TScrollInfo;                 //      
    siH: TScrollInfo;                 //    
    cEdit: PControl;                  //  
    pMouse: TPoint;                   // 
    rTextBlok: TRect;                   //  
    GRFont: PGraphicTool;
    EditText: boolean;                //  
    _Data:TData;
  //   ARoot, AParent: PTree;
     FList:PList;
 
    procedure UpdateVScroll;               
    procedure UpdateHScroll;
    procedure Draw;
    procedure DrawFocus;
    procedure SetNewFont(Value:TFontRec);
    procedure AddElement; 
//    procedure AddLine;     ////
    procedure SelectElement(ind: integer);
    procedure SelectAllElements;
    procedure DeleteElement(ind: integer);
 //   procedure ChangeSizeRects;
    procedure ChangeTextRect;
    procedure ChangeSize;
    procedure ChangeText;
    procedure MoveSelectKey(direction: byte);
    procedure MoveSelectMouse;
    procedure DeleteSelect; 
//    procedure ChangeColor(ind: byte);

  //  function SelectColor:Tcolor;
    function CreateRegion(ind,x,y,w,h:integer):HRGN;
    procedure DrawArrow(pDC: HDC; Op, Xar, Yar: integer);
 //   function RotateText(r: TRect; ind:integer; pDC: HDC):TRect; 
    procedure _onSize(Sender: PObj);
    procedure _onPaint(Sender: PControl; DC: HDC);
    procedure _onResize(Sender: PObj);override;
    protected
    procedure _onMouseDown(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure _onMouseUp(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure _onMouseMove(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure _onDblClick(Sender: PControl; var Mouse: TMouseEventData); override;
    function  _onCatchMessage(var Msg: TMsg; var Rslt: Integer):boolean;
   public 
    //_data_NameNode:THI_Event;
   // _data_Node:THI_Event;
    _data_FillColor:THI_Event;
    _data_FrameColor:THI_Event;
    _data_Prima:THI_Event;
    _data_Second:THI_Event;
    _prop_UseMenu:boolean; 
    _prop_RedactText:boolean;    
    _prop_StepSizeElement:integer;
    _prop_SizeAlign:integer; 
    _prop_DefWidth:integer;
    _prop_DefHeight:integer;
    _prop_FillColor:TColor;
    _prop_FrameColor:TColor;
    
    _event_onNode: THI_Event;
    _event_onCreateNode: THI_Event;  
    
    procedure _work_doTree(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);	   
    property _prop_Font:TFontRec write SetNewFont;
    procedure Init; override;
    destructor Destroy; override;
  end;

implementation  
var OldLength: Integer;    //,Fill
NodeNumb: Integer=3;
CountNodeLevel: Integer=-1;
CountNodeLevel2: Integer=0;
SumStr: string;
function TextWidth(s: string; StepSizeElement:integer; GFont: PGraphicTool):integer;
var   SizeFont: TSize;
      DC: HDC; 
begin  
   DC := CreateCompatibleDC(0);
   SelectObject(DC, GFont.Handle);
   GetTextExtentPoint32(DC, PChar(s), Length(s), SizeFont);
   DeleteDC(DC);
   Result :=SizeFont.cx + (StepSizeElement * 2);
end;
 
function TextHeight(s: string; StepSizeElement:integer; GFont: PGraphicTool):integer;
var   SizeFont: TSize;
      DC: HDC;
begin  
   DC := CreateCompatibleDC(0);
   SelectObject(DC, GFont.Handle);
   GetTextExtentPoint32(DC, PChar(s), Length(s), SizeFont);
   DeleteDC(DC);
   Result :=SizeFont.cy + StepSizeElement;
end; 
 
destructor THITextBlok.Destroy;
var i: integer;
begin
    Bmp.Free;   
//    PM.Free;
    GRFont.free;
    Control.OnMessage := OldMes;
    for i := 0 to eList.Count - 1 do
     begin
      DeleteElement(i);                  //  (, )     (iType) 
      Dispose(PFigure(eList.Items[i]));
     end;
    eList.Free; 
	FList.Free; 
  inherited;
end;

procedure THITextBlok.Init;
begin
    Control := NewPaintbox(FParent);
    cVScroll := _NewControl(Control, 'SCROLLBAR', WS_VISIBLE or WS_CHILD or SBS_VERT, FALSE, nil );
    cHScroll := _NewControl(Control, 'SCROLLBAR', WS_VISIBLE or WS_CHILD or SBS_HORZ, FALSE, nil );
    cEdit := NewEditbox(FParent, [eoMultiline,eoNoHideSel,eoNoVScroll,eoNoHScroll]);
    cEdit.TextAlign := TTextAlign(2);
    cEdit.Style:= cEdit.Style and not ws_BORDER;  
    OldMes := Control.OnMessage;
    Control.OnMessage := _onCatchMessage;
    Control.OnMouseDblClk   := _onDblClick;    /////
    Control.OnMouseDown     := _OnMouseDown;  ////
    Control.OnMouseUp       := _OnMouseUp;    ////

    inherited;     
    with Control{$ifndef F_P}^{$endif} do begin
     OnPaint := _OnPaint;
     OnResize := _OnSize;
    end;
    eList := newList;
    FList := newList;
    Bmp := NewBitmap(0,0);
    Bmp.BkColor := Control.Color;
    Bmp.Width := max(Control.Width,1);
    Bmp.Height := max(Control.Height,1);
    siH.nMin := 0;
    siV.nMin := 0;
    cEdit.Visible := False;
    EditText := False;
    cVScroll.Visible := False;
//    cVScroll.Color := Color2RGB(clBtnHighlight);
    cVScroll.Color := $E7E9EB;
    cVScroll.Width := 16;       //10
    cHScroll.Visible := False;
    cHScroll.Color := $E7E9EB;
 //     cHScroll.Color := Color2RGB(clBtnHighlight);   E3E6E6  E5EEF2
    cHScroll.Height := 16;    //10
    siV.cbSize := sizeof(siV);
    siH.cbSize := sizeof(siH);
    UpdateVScroll;
    UpdateHScroll;
    _OnSize(Control);
end;

function THITextBlok.CreateRegion;
var p:array [0..3] of TPoint;
    rgn1, rgn2, rgn3: HRGN;
begin      
     Result := CreateRoundRectRgn(x, y, x + w + 1, y + h + 1, 7, 7);      
end;


procedure THITextBlok.AddElement;
var newElem: PFigure;
  Level, i,x,y,m,m1,m2,FColor,Fillc: integer;
 //   dt:PData;
begin
            m1:= ToIntegerEvent(_data_Prima);     ////////////
            m2:= ToIntegerEvent(_data_Second);  ////////////
            Fillc:= ToIntegerEvent(_data_FillColor); //////////
            FColor:= ToIntegerEvent(_data_FrameColor);
    newElem := new(PFigure);
	newElem.cFill := Fillc; 
	newElem.cFrame :=  FColor; 
    newElem.sText := SumStr; 
    CountNodeLevel:=CountNodeLevel+1;
    newElem.ParentrRect:=CountNodeLevel;
	 x := _prop_StepSizeElement ;   
      with PFigure(eList.Items[eList.Count - 1])^ do
      begin  if eList.Count<>0 then  
        if   x   <=  (rRect.Right + _prop_SizeAlign) then  x := rRect.Right + 1 ;
       end; 
			if  (m1=-1) and (m2=-1)then
			begin
         	newElem.Firstf:= -1;     ////////////
            newElem.Secondf:= -1;  //////////// 
            end
            else
        begin
            if (m1 <> -1) and  (m2 = -1) then
             begin
			 newElem.Firstf:= m1; 
			 newElem.Secondf:= -1;
			 if    FList.Count = 0  then begin NodeNumb :=3 ; CountNodeLevel2:=0;  end;
			 FList.Add(Pointer(Fillc));
			 if CountNodeLevel2=0 then  CountNodeLevel2:=1 else dec(NodeNumb); 			 
			 end 
			 else                   
          //  if (m1 = -1) and  (m2 <> -1)  then
            begin 
                if CountNodeLevel2=0 then 
				  if integer(FList.Items[FList.Count - 1])<> Fillc  then
				   begin CountNodeLevel2:=1; dec(NodeNumb) end else CountNodeLevel2:=0     
				  else 
				  begin dec(NodeNumb); CountNodeLevel2:=0 end;
			    inc(NodeNumb);
			    FList.Delete(FList.Count - 1);
			    m := CountNodeLevel-1;        
            	while ( m <> -1) do 
			    with PFigure(eList.Items[m])^ do  			            
			    begin
			   if Firstf = m2  then
			      begin 
			      Firstf := -2; 	//1111		   
			      newElem.Secondf := m;
			      newElem.Firstf := -1;
			      Break;
				  end;        
			    dec(m);        
                end; 
	       end; 
        end;
        
      y :=    _prop_SizeAlign * NodeNumb ;
    newElem.gFont := nil; 
     newElem.hRegn := CreateRegion(0, x, y, TextWidth(newElem.sText,_prop_StepSizeElement,GRFont), TextHeight(newElem.sText,_prop_StepSizeElement,GRFont));
     newElem.rRect := MakeRect(x, y, x + TextWidth(newElem.sText,_prop_StepSizeElement,GRFont), y + TextHeight(newElem.sText,_prop_StepSizeElement,GRFont));
     newElem.rText := newElem.rRect; 
       //    _hi_OnEvent(_event_onCreateNode,dt^);    ///  			       
     eList.Add(newElem);
    ChangeSize;   
    Control.Invalidate; 
end;

procedure THITextBlok.SelectElement;
begin
    SetLength(SelectUnit, 1);
    SelectUnit[0] := ind;
 //   ChangeSizeRects;
end;

procedure THITextBlok.SelectAllElements;
var i: integer;
begin
    if eList.Count = 0 then exit;
    SetLength(SelectUnit, eList.Count);
    for i := 0 to  eList.Count - 1 do
     SelectUnit[i] := i;
    Draw;
    Control.Invalidate;
end;

procedure THITextBlok.DeleteElement;
begin 
    with PFigure(eList.Items[ind])^ do
      begin 
       DeleteObject(hRegn);
       if Assigned(gFont) then gFont.free;      
      end;
end; 

procedure THITextBlok.ChangeTextRect;
var pDC: HDC;
    newRect: TRect;
    h: integer;
begin
    if Length(SelectUnit) <> 1 then exit;
    pDC := CreateCompatibleDC(0);
    with PFigure(eList.Items[SelectUnit[0]])^ do
     begin
     if Assigned(gFont) then
      SelectObject(pDC, gFont.Handle)
      else SelectObject(pDC, GRFont.Handle);      
      newRect := rRect;
      rText := rRect;                                                                    
      h := DrawText(pDC,PChar(sText), -1, newRect, flag or DT_CENTER); //   DT_CALCRECT
      SetRect(rText, rText.Left, rText.Top + (rText.Bottom - newRect.Bottom) div 2, rText.Right, newRect.Bottom + (rText.Bottom - newRect.Bottom) div 2);
      SetRect(rText, rText.Left + (rText.Right - newRect.Right) div 2, rText.Top, rText.Right - (rText.Right - newRect.Right) div 2, rText.Bottom);
      DeleteDC(pDC);
    end;
end; 

{ procedure THITextBlok.ChangeSizeRects;
var r: TRect;
    mx,my: integer;	 
	                                         
 begin
   if Length(SelectUnit) <> 1 then exit;  
    r := PFigure(eList.Items[SelectUnit[0]]).rRect;
//	with PFigure(eList.Items[SelectUnit[0]])^ do  
    mx := (r.Right - r.Left) div 2 + r.Left; 
    my := (r.Bottom - r.Top) div 2 + r.Top;  
 //   SetRect (r,r.Left,r.Top, r.Left + 200, r.Bottom); 
    
 //     r.Right:=r.Left+200;         
  //   _hi_OnEvent(_event_onNode,r.Right);
  //newElem.rRect := MakeRect(x, y, x + TextWidth(newElem.sText,_prop_StepSizeElement,GRFont), y + TextHeight(newElem.sText,_prop_StepSizeElement,GRFont));
  
end;  }  



procedure THITextBlok.ChangeSize;
var i: integer; 
begin   
    cVScroll.Height := Control.Height - 16; //16  10  
    cVScroll.Left   := Control.Width - 16;    //16  10
    cHScroll.Top    := Control.Height - 16;    //16  10
    cHScroll.Width  := Control.Width - 16;      //16  10
    if eList.Count = 0 then
     begin
      cVScroll.Visible := False;
      cHScroll.Visible := False;
      Exit;
     end;
    rTextBlok := PFigure(eList.Items[0]).rRect;
    for i := 1 to eList.Count - 1 do
     with PFigure(eList.Items[i])^ do
      begin
       rTextBlok.Left :=   min(rTextBlok.Left,   rRect.Left);
       rTextBlok.Top :=    min(rTextBlok.Top,    rRect.Top);
       rTextBlok.Right :=  max(rTextBlok.Right,  rRect.Right); 
       rTextBlok.Bottom := max(rTextBlok.Bottom, rRect.Bottom);
      end;
    if (Bmp.Width < rTextBlok.Right) or (0 > rTextBlok.Left) then
     begin
      cHScroll.Visible := True;
      cHScroll.Width := Control.Width;
     end
    else
     begin
      cHScroll.Visible := False;
      siH.nPos := 0;
     end;
    if (Bmp.Height < rTextBlok.Bottom) or (0 > rTextBlok.Top) then
     begin
      cVScroll.Visible := True;
      if cHScroll.Visible then
       begin
        cVScroll.Height := Control.Height - 16;     //10
        cHScroll.Width := Control.Width ;     //10
       end
      else cVScroll.Height := Control.Height;
     end
    else
     begin
      cVScroll.Visible := False;
      siV.nPos := 0;
     end; 
    UpdateVScroll;
    UpdateHScroll;
end;

procedure THITextBlok.ChangeText;
{
//var r: TRect;
//newElem: PFigure;
//x,y,xs,ys: integer;
begin
    if Length(SelectUnit) <> 1 then exit;   ///////////
  //  EditText := True; 
 //   r := PFigure(eList.Items[SelectUnit[0]]).rRect;
 //   cEdit.Text := PFigure(eList.Items[SelectUnit[0]]).sText;
 //   cEdit.SetPosition(Control.Left + r.Left + 1 - siH.nPos, Control.Top + r.Top + 1 - siV.nPos);
       
  //     cEdit.SetSize(300, r.Bottom - r.Top - 2);
 //      cEdit.Color := PFigure(eList.Items[SelectUnit[0]]).cFill;
 //   cEdit.BringToFront;
 //   cEdit.Focused := True;
     _hi_OnEvent(_event_onNode,PFigure(eList.Items[SelectUnit[0]]).ParentrRect);  ///////

//    cEdit.Visible := True;
//   cEdit.SelStart := 9000; 
    
end;    }
var r: TRect;
begin
    if Length(SelectUnit) <> 1 then exit;
    EditText := True; 
    r := PFigure(eList.Items[SelectUnit[0]]).rRect;
    cEdit.Text := PFigure(eList.Items[SelectUnit[0]]).sText;
    cEdit.SetPosition(Control.Left + r.Left + 1 - siH.nPos, Control.Top + r.Top + 1 - siV.nPos);
    cEdit.SetSize(r.Right - r.Left, r.Bottom - r.Top);  
       cEdit.Color := PFigure(eList.Items[SelectUnit[0]]).cFill;
    cEdit.BringToFront;
    cEdit.Focused := True;
    cEdit.Visible := True;
    cEdit.SelStart := 9000;
end;


{ procedure THITextBlok.ChangeColor;
var cl: TColor;
    i: integer;
begin
    if Length(SelectUnit) = 0 then exit;
  //  cl := SelectColor;
    for i := 0 to  Length(SelectUnit) - 1 do
     case ind of
      0: PFigure(eList.Items[SelectUnit[i]]).cFill := cl;
      1: PFigure(eList.Items[SelectUnit[i]]).cFrame := cl;
     end;
    Control.Invalidate;
end;  }

procedure THITextBlok.MoveSelectKey;
var i,x,y: integer;
begin
    if Length(SelectUnit) = 0 then exit;
    x := 0; y := 0;
    case direction of
 //    0: x := - _prop_SizeAlign;  
     0: x := - 10;
     1: y := - _prop_SizeAlign;
//     2: x := _prop_SizeAlign;
     2: x := 10;
     3: y := _prop_SizeAlign;
    end; 
    for i := 0 to  Length(SelectUnit) - 1 do
     begin
      OffsetRgn(PFigure(eList.Items[SelectUnit[i]]).hRegn, x, y);
      OffsetRect(PFigure(eList.Items[SelectUnit[i]]).rRect, x, y);
      OffsetRect(PFigure(eList.Items[SelectUnit[i]]).rText, x, y);
      
     end; 
    Control.Invalidate;
end;

procedure THITextBlok.MoveSelectMouse;
var i,x,y,xa,ya,xs,ys: integer;
begin
    x := (ms.X - pMouse.X);
    y := (ms.Y - pMouse.Y);
    if x > 0 then xa := x else xa := -x;
    if y > 0 then ya := y else ya := -y;
//    if (xa > _prop_SizeAlign) or (ya > _prop_SizeAlign) then 
      if (xa > 10) or (ya > _prop_SizeAlign) then
     begin
 //     xs := x div _prop_SizeAlign * _prop_SizeAlign;
        xs := x div 10 * 10;
      ys := y div _prop_SizeAlign * _prop_SizeAlign;
      pMouse.X := ms.X - (x - xs);
      pMouse.Y := ms.Y - (y - ys);
      for i := 0 to  Length(SelectUnit) - 1 do
       begin
        OffsetRgn(PFigure(eList.Items[SelectUnit[i]]).hRegn, xs, ys);
        OffsetRect(PFigure(eList.Items[SelectUnit[i]]).rRect, xs, ys);
        OffsetRect(PFigure(eList.Items[SelectUnit[i]]).rText, xs, ys);
       end;
 //    if Length(SelectUnit) = 1 then ChangeSizeRects;
      Draw;  
      Control.Invalidate;
     end; 
end;

procedure THITextBlok.DeleteSelect;
var i,s: integer;
begin
    if Length(SelectUnit) = 0 then exit;
    for i := Length(SelectUnit) - 1  downto 0 do
     begin
      s := SelectUnit[i]; 
      DeleteElement(s);
      Dispose(PFigure(eList.Items[s])); 
      eList.Delete(s);
      CountNodeLevel:=CountNodeLevel - s;
     end;
    SetLength(SelectUnit, 0); 
    ChangeSize;
    Control.Invalidate;
end;

{function THITextBlok.SelectColor;
var cd:PColorDialog;
begin
    cd := NewColorDialog(ccoShortOpen);
    cd.OwnerWindow := ReadHandle;
    cd.Color := PFigure(eList.Items[SelectUnit[0]]).cFill;
    if cd.Execute then
     Result := cd.Color;
end; }

procedure THITextBlok.DrawFocus; 
var pDC: HDC;
begin
    pDC := GetDC(Control.Handle);
    DrawFocusRect(pDC, selRect);
    if (pMouse.X < ms.X) and (pMouse.Y < ms.Y) then SetRect(selRect, pMouse.X, pMouse.Y, ms.X, ms.Y)
     else if (pMouse.X > ms.X) and (pMouse.Y < ms.Y) then SetRect(selRect, ms.X, pMouse.Y, pMouse.X, ms.Y)
      else if (pMouse.X < ms.X) and (pMouse.Y > ms.Y) then SetRect(selRect, pMouse.X, ms.Y, ms.X, pMouse.Y)
       else SetRect(selRect, ms.X, ms.Y, pMouse.X, pMouse.Y);
    DrawFocusRect(pDC, selRect);
    ReleaseDC(0, pDC);
end;

procedure THITextBlok.DrawArrow;
var Points: array[0..2] of Tpoint;
begin
     SelectObject(pDC, GetStockObject(BLACK_BRUSH));    
     SelectObject(pDC, GetStockObject(BLACK_PEN));
      case Op of
 0:
     begin
       Points[0]:= MakePoint(Xar - 3, Yar - 3);    
       Points[1]:= MakePoint(Xar - 3, Yar + 3);
       Points[2]:= MakePoint(Xar , Yar);
      end;
1:    begin 
       Points[0]:= MakePoint(Xar - 3, Yar + 3);// Points[0]:= MakePoint(150 - 6, Yar - 2);
       Points[1]:= MakePoint(Xar + 3, Yar + 3);// Points[1]:= MakePoint(150 - 12, Yar - 2);
       Points[2]:= MakePoint(Xar, Yar);// Points[2]:= MakePoint(150 - 9, Yar + 1);
      end;
2:   
     begin
       Points[0]:= MakePoint(Xar + 3, Yar - 4);
       Points[1]:= MakePoint(Xar - 3, Yar - 4);
       Points[2]:= MakePoint(Xar , Yar-1);
     end;
  end;   
     Polygon(pDC, Points,3);
end;

///////////    
{ function THITextBlok.RotateText;
var wXFORM: XFORM;
    x, y: integer;
    a: real;
begin
    FillChar(wXFORM, SizeOf(wXFORM), #0);
    case ind of
     -1: begin
          wXFORM.eM11 := 1;
          wXFORM.eM22 := 1;
          SetWorldTransform(pDC, wXFORM);
          SetViewportOrgEx(pDC, 0, 0, nil);
          SetGraphicsMode(pDC, GM_COMPATIBLE);
          exit;
         end;
      1: a := 0.5;
      2: a := 1.5;
    end;  
    wXFORM.eM11 := Cos(a*pi);
    wXFORM.eM12 := -Sin(a*pi);
    wXFORM.eM21 := -wXFORM.eM12;
    wXFORM.eM22 := wXFORM.eM11;
    x := r.Left + (r.Right - r.Left) div 2;
    y := r.Top + (r.Bottom - r.Top) div 2; 
    SetViewportOrgEx(pDC, x, y, nil);
    SetGraphicsMode(pDC, GM_ADVANCED);
    SetWorldTransform(pDC, wXFORM);
    OffsetRect(r, -x, -y);
    Result := r;
end;  } 

procedure THITextBlok.Draw;
var i, i2,x,y,k,j,j1,r,l,m: integer;
    pDC: HDC;
    Br: HBrush;
//    Pen: HPen;  
    rect: TRect;
    s: string;

{    procedure SetDrawFont(fnt: PGraphicTool);
    begin
     if Assigned(fnt) then
      begin  
       SetTextColor(pDC, Color2RGB(fnt.Color));
       SelectObject(pDC, fnt.Handle);      
      end   
     else
      begin
       SetTextColor(pDC, Color2RGB(GRFont.Color));
       SelectObject(pDC, GRFont.Handle);
     end;  
    end;  }
    
begin 
    pDC := Bmp.Canvas.Handle;
    SetViewportOrgEx(pDC, 0, 0, nil);
    Bmp.Canvas.Brush.BrushStyle := bsSolid;
    Bmp.Canvas.FillRect(Bmp.BoundsRect);
    if eList.Count = 0 then exit;
    SetBkMode(pDC, TRANSPARENT);
    SetViewportOrgEx(pDC, -siH.nPos, -siV.nPos, nil); //     	  
    for i := 0 to  eList.Count - 1 do    
     with PFigure(eList.Items[i])^ do
            begin   //1    
              br := CreateSolidBrush(cFill);
              FillRgn(pDC, hRegn, Br);
              DeleteObject(br);
              br := CreateSolidBrush(cFrame);
              FrameRgn(pDC, hRegn, br, 1, 1);
          //    SetDrawFont(gFont);
      if Assigned(gFont) then
      begin  
       SetTextColor(pDC, Color2RGB(gFont.Color));
       SelectObject(pDC, gFont.Handle);      
      end   
     else
      begin
       SetTextColor(pDC, Color2RGB(GRFont.Color));
       SelectObject(pDC, GRFont.Handle);
     end;                 
              DrawText(pDC,PChar(sText), -1, rText, flag);             
              DeleteObject(br); 
			if (Firstf <> -1) or (Secondf <> -1) then 
  			begin //2   
			if Secondf = -1 then  
			      begin //3
			      k:= rRect.Left + (rRect.Right - rRect.Left) div 2;  
			      MoveToEx(pDC, k, rRect.Bottom, nil);
			      j := rRect.Bottom + 8;
			      LineTo(pDC, k, j);
			      DrawArrow (pDC,2,k,j );
			      end //3
			  else    
			      begin //4 
			     r := rRect.Left + (rRect.Right - rRect.Left) div 2 ;
			     y := rRect.Bottom ;
			      m := i;  
			      j1 := Secondf;
			   //   m:= m-1; 
			    //  r :=  rRect.Bottom; 
			            while ( m <> -1) do 
			            with PFigure(eList.Items[m])^ do  			            
			            begin //5	
			//	 _hi_OnEvent(_event_onNode,Firstf);			
			//	 _hi_OnEvent(_event_onCreateNode,Secondf);		            
			            if ParentrRect = j1 then
			               begin //6
						   if y >=	rRect.Bottom then x	:= y + 8 else x	:= rRect.Bottom + 8	;              
						   MoveToEx(pDC, rRect.Left + (rRect.Right - rRect.Left) div 2, rRect.Bottom, nil);  
			               LineTo(pDC, rRect.Left + (rRect.Right - rRect.Left) div 2, x );  
			               LineTo(pDC, r, x );
			               LineTo(pDC, r,y);
			               DrawArrow(pDC,1, r,y);
			               Break;
						   end; //6
			            dec(m);
			            end; //5		      
			     end; //4 	  
	    	 end; //2 		            
           end;  //1
          
     if Length(SelectUnit) > 1 then   //  
     for i := 0 to  Length(SelectUnit) - 1 do  
      begin  
       rect := PFigure(eList.Items[SelectUnit[i]]).rRect;
       InflateRect(rect,1,1);
       DrawFocusRect(pDC,rect);
      end;
    if Length(SelectUnit) = 1 then   //  
     begin
      rect := PFigure(eList.Items[SelectUnit[0]]).rRect;
      InflateRect(rect,1,1);
      DrawFocusRect(pDC,rect);      
     end;
    if cVScroll.Visible and cHScroll.Visible then
     begin
      SetRect(rect, Control.Width - 16, Control.Height - 16, Control.Width, Control.Height);
      OffsetRect(rect, siH.nPos, siV.nPos);
      DrawEdge(pDC, rect, EDGE_SUNKEN, 18432);        //BF_SOFT     
     end;  
end;  

procedure THITextBlok._work_doTree;
var I,NewLength,Level,CountNodeLevelN: Integer;
newElem: PFigure;
begin 
SumStr:=Tostring(_Data);
//  NodeNumb :=3 ;     //  
  inc(siH.nPos,  TextWidth(SumStr,_prop_StepSizeElement,GRFont) );
  inc(siV.nPos,  _prop_SizeAlign);  
   AddElement; 
//    NodeNumb := NodeNumb + 1 ; 
end;

procedure THITextBlok._work_doClear;

var i: integer;
begin
    if eList.Count = 0 then exit;
    CountNodeLevel:=-1;
    NodeNumb:=3;   ///
    CountNodeLevel2:=0;  ///
 //   for i := FList.Count - 1 downto  0 do   FList.Delete(i);  ///
 //   FList.Count := -1;      ///
      FList.Free;  FList := newList;
    SetLength(SelectUnit, eList.Count);     
    for i := 0 to  eList.Count - 1 do 
     SelectUnit[i] := i;  
    DeleteSelect;
    Control.Invalidate;    
end; 

procedure THITextBlok._OnPaint;
begin
    Draw;
    Bmp.Draw(DC,0,0);
end;

procedure THITextBlok._OnResize;
begin
    //ChangeSize;
    inherited;
end;

procedure THITextBlok._onSize;
begin
    Bmp.Width := max(Control.Width,1);
    Bmp.Height := max(Control.Height,1);
     ChangeSize;
    Control.Invalidate;
end;

procedure THITextBlok._onMouseDown;
var i,s: integer;
    rect: TRect; 
    dt:TData;
begin  
    Ms := Mouse;
    Control.Focused := true;
    SetCapture(Control.GetWindowHandle);
    if EditText then  //   
     begin
      PFigure(eList.Items[SelectUnit[0]]).sText := cEdit.Text;
      cEdit.Visible := False;
      EditText := False;
      ChangeTextRect;
     end; 
    case integer(Mouse.Button) of 
     1: begin
         pMouse := MakePoint(Ms.X, Ms.Y);  //    
   
           s := -1;
           for i := eList.Count - 1 downto 0 do 
                 if PtInRegion (PFigure(eList.Items[i]).hRegn, Ms.X + siH.nPos, Ms.Y + siV.nPos) then
                    begin
                     s := i;  //      
                     Break; 
            end;
           if s = -1 then SetLength(SelectUnit, 0)  //  
            else
             for i := Length(SelectUnit) - 1 downto 0 do
              if SelectUnit[i] = s then
               begin                          
                s := -1;
                Break;
               end;
           if s > -1 then SelectElement(s);
          // _hi_OnEvent(_event_onCreateNode,s);   /// 
           Control.Invalidate;        
        end;
      2:  for i := eList.Count - 1 downto 0 do 
          with PFigure(eList.Items[i])^ do
          begin  
         if PtInRegion (PFigure(eList.Items[i]).hRegn, Ms.X + siH.nPos, Ms.Y + siV.nPos) then
              begin 
        //      dt:= PFigure(eList.Items[i]).Node;
                 _hi_OnEvent(_event_onNode,i);  //ParentrRect                                  
                  Break;
              end;
          end;  
     3: begin
         pMouse := MakePoint(ms.X, ms.Y);
         Control.CursorLoad(0, MakeIntResource(crSizeAll));
         MoveSelectMouse ; 
        end;
    end;   
    inherited;
end;

procedure THITextBlok._onMouseUp;
var i, ind: integer;
begin
    inherited;
    ReleaseCapture;
    case integer(Mouse.Button) of
     1: begin
         if not IsRectEmpty(selRect) then
          begin
           OffsetRect(selRect, siH.nPos, siV.nPos);
           for i := 0 to  eList.Count - 1 do
            if RectInRegion(PFigure(eList.Items[i]).hRegn, selRect) then  
             begin
              ind := Length(SelectUnit);
              SetLength(SelectUnit, ind + 1);
              SelectUnit[ind] := i;
             end;
            if Length(SelectUnit) > 1 then SortIntegerArray(SelectUnit) ;   //  
   //          else if Length(SelectUnit) = 1 then ChangeSizeRects;
            SetRectEmpty(selRect);
          end;
         ChangeSize;
         Control.Invalidate;
        end;
     3: Control.CursorLoad(0, MakeIntResource(crDefault));
    end;
    
end;

procedure THITextBlok._onMouseMove;
var inSize: boolean;
    i: integer;
begin
    inherited;    
    case integer(Ms.Shift) of
 
     1: if Length(SelectUnit) = 0 then DrawFocus       
          else if not EditText then MoveSelectMouse; 
    16: if cVScroll.Visible or cHScroll.Visible then 
         begin
          siH.nPos := siH.nPos + pMouse.X - ms.X;
          if siH.nMax < siH.nPos then siH.nPos := siH.nMax
           else if siH.nMin > siH.nPos then siH.nPos := siH.nMin; 
          siV.nPos := siV.nPos + pMouse.Y - ms.Y;
          if siV.nMax < siV.nPos then siV.nPos := siV.nMax
           else if siV.nMin > siV.nPos then siV.nPos := siV.nMin; 
          pMouse := MakePoint(ms.X, ms.Y);
          UpdateHScroll;
          UpdateVScroll;
          Control.Invalidate; 
         end;
    end;
    Ms := Mouse; 
end;  


procedure THITextBlok._onDblClick;
begin
//   inherited;
    EditText := True; 
   ChangeText;
_hi_OnEvent(_event_onCreateNode,555);
   inherited;
end;

function THITextBlok._onCatchMessage;
var m: PMenu;
begin
  Result := false;
  case Msg.message of
   WM_KEYUP  : ChangeSize;
   WM_KEYDOWN: begin                 
                case Msg.wParam of
              37..40: MoveSelectKey(Msg.wParam - 37); //  left,up,rught,down 
			  46: DeleteSelect ;            
                end;
              end; 
   WM_VSCROLL: if dword(Msg.lParam) = cVScroll.Handle then
               begin
                siV.fMask := SIF_POS or SIF_TRACKPOS;
                GetScrollInfo(cVScroll.Handle, SB_CTL, siV);
                case LOWORD(Msg.wParam)  of
                 SB_BOTTOM,SB_LINERIGHT: if siV.nPos < siV.nMax then inc(siV.nPos);
                 SB_LINELEFT,SB_TOP:     if siV.nPos > siV.nMin then dec(siV.nPos);
                 SB_PAGELEFT:            dec(siV.nPos, 32);
                 SB_PAGERIGHT:           inc(siV.nPos, 32);
                 SB_THUMBPOSITION,
                 SB_THUMBTRACK:          siV.nPos := siV.nTrackPos;
                end;
                UpdateVScroll;
                Control.Invalidate;
                result := true;
                Rslt := 0;
               end;
   WM_HSCROLL: if dword(Msg.lParam) = cHScroll.Handle then
               begin
                siH.fMask := SIF_POS or SIF_TRACKPOS;
                GetScrollInfo(cHScroll.Handle, SB_CTL, siH);
                case LOWORD(Msg.wParam)  of
                 SB_BOTTOM,SB_LINERIGHT: if siH.nPos < siH.nMax then inc(siH.nPos);
                 SB_LINELEFT,SB_TOP:     if siH.nPos > siH.nMin then dec(siH.nPos);
                 SB_PAGELEFT:            dec(siH.nPos, 32);
                 SB_PAGERIGHT:           inc(siH.nPos, 32);
                 SB_THUMBPOSITION,
                 SB_THUMBTRACK:          siH.nPos := siH.nTrackPos;
                end;
                UpdateHScroll;
                Control.Invalidate;
                result := true;
                Rslt := 0;
               end;
  end;
  Result := Result;   
end;

procedure THITextBlok.UpdateVScroll;
begin
    siV.fMask := SIF_RANGE or SIF_PAGE or SIF_POS;
    if rTextBlok.Top < 0 then siV.nMin := rTextBlok.Top
     else siV.nMin := 0;
    if rTextBlok.Bottom > Control.Height then     
	 siV.nMax := rTextBlok.Bottom - Control.Height + 20	
     else siV.nMax := 0;
    SetScrollInfo(cVScroll.Handle, SB_CTL, siV, false);
    cVScroll.Invalidate;
end;

procedure THITextBlok.UpdateHScroll;
begin
    siH.fMask := SIF_RANGE or SIF_PAGE or SIF_POS;
    if rTextBlok.Left < 0 then siH.nMin := rTextBlok.Left
     else siH.nMin := 0;
    if rTextBlok.Right > Control.Width then	
//	 inc(siH.nPos, 32);
	 siH.nMax := rTextBlok.Right - Control.Width + 20 
//	SetScrollPos(cHScroll.Handle, SB_CTL ,siH.nPos, TRUE);	 
     else siH.nMax := 0;       
    SetScrollInfo(cHScroll.Handle, SB_CTL, siH, false);    
    cHScroll.Invalidate;
        //     inc(siH.nPos, 32);
  //   SetScrollPos(cHScroll.Handle, SB_CTL, rTextBlok.Right - Control.Width + 20, TRUE);////
end; 

procedure THITextBlok.SetNewFont;
begin
   if Assigned(GRFont) then GRFont.free;
   GRFont := NewFont;
   GRFont.Color:= Value.Color;
   Share.SetFont(GRFont,Value.Style);
   GRFont.FontName:= Value.Name;
   GRFont.FontHeight:= _hi_SizeFnt(Value.Size);
   GRFont.FontCharset:= Value.CharSet;
end;

end.
